package com.cxytiandi.baidu_pan.controller;

import java.io.IOException;
import java.util.Map;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import com.cxytiandi.baidu_pan.domain.es.ResourceBean;
import com.cxytiandi.baidu_pan.service.ResourceService;
import com.cxytiandi.baidu_pan.util.IpUtils;
import com.cxytiandi.baidu_pan.util.PageBean;

@Controller
public class SearchConteoller {
	@Autowired
	private ResourceService resourceService;
	
	@RequestMapping("/search")
	public String search(@RequestParam("keyword")String keyword,
			@RequestParam("page")Integer page,
			@RequestParam("type")Integer type, Map<String, Object> model, HttpServletRequest request) {
		if (page == null) {
			page = 1;
		}
		if (type == null) {
			type = 0;
		}
		PageBean<ResourceBean> bean = null;
		if (StringUtils.isNotBlank(keyword)) {
			bean = resourceService.listForPage(keyword, type, page, 10);
		} else {
			bean = new PageBean<>();
		}
		model.put("datas", bean);
		model.put("keyword", keyword);
		model.put("basePath", IpUtils.getBasePath(request));
		model.put("type", type);
		return "search/index";
	}
	
	@RequestMapping("/resource/{id}")
	public String searchDetail(@PathVariable("id") String id, @RequestParam("keyword")String keyword,
			Map<String, Object> model, HttpServletRequest request) {
		if (StringUtils.isNotBlank(id)) {
			ResourceBean re = resourceService.getResource(id);
			if (re == null) {
				return "index/index";
			} else {
				resourceService.addVisitCount(id);
			}
			//model.put("userResources", resourceService.listByUser(re.getHomeUrl()));
			model.put("userResources", resourceService.listForPage("软件", 0, 1, 10).getList());
			model.put("resource", re);
			model.put("keyword", keyword);
			model.put("basePath", IpUtils.getBasePath(request));
			model.put("type", 0);
			return "search/detail";
		}
		return "index/index";
	}
	
	@RequestMapping("/resource/req/{id}")
	public String resourceReq(@PathVariable("id") String id, HttpServletResponse response) throws IOException {
		if (StringUtils.isNotBlank(id)) {
			ResourceBean re = resourceService.getResource(id);
			if (re == null) {
				return "index/index";
			} else {
				resourceService.addDownloadCount(id);
			}
			response.sendRedirect(re.getUrl());
		}
		return "index/index";
	}
}
