package com.cxytiandi.baidu_pan.domain;

import java.util.Date;
import org.springframework.data.annotation.Id;
import org.springframework.data.mongodb.core.index.Indexed;
import org.springframework.data.mongodb.core.mapping.Document;
import org.springframework.data.mongodb.core.mapping.Field;

/**
 * 网盘资源
 * @author yinjihuan
 *
 */
@Document(collection="pan")
public class Resource {
	@Id
	private String id;
	@Field("date")
	private String date;
	@Field("hm_href")
	private String homeHref;
	@Field("hm_url")
	private String homeUrl;
	@Field("size")
	private String size;
	@Field("un")
	private String username;
	@Field("href")
	private String href;
	@Field("title")
	private String title;
	@Field("type")
	private String type;
	@Field("url")
	@Indexed(unique=true, name="url_unique_idx", background=true)
	private String url;
	@Field("v_count")
	private long visitCount;
	@Field("d_count")
	private long downloadCount;
	@Field("m_date")
	private Date modifyDate;
	public String getId() {
		return id;
	}
	public void setId(String id) {
		this.id = id;
	}
	public String getDate() {
		return date;
	}
	public void setDate(String date) {
		this.date = date;
	}
	public String getHomeHref() {
		return homeHref;
	}
	public void setHomeHref(String homeHref) {
		this.homeHref = homeHref;
	}
	public String getHomeUrl() {
		return homeUrl;
	}
	public void setHomeUrl(String homeUrl) {
		this.homeUrl = homeUrl;
	}
	public String getSize() {
		return size;
	}
	public void setSize(String size) {
		this.size = size;
	}
	public String getUsername() {
		return username;
	}
	public void setUsername(String username) {
		this.username = username;
	}
	public String getHref() {
		return href;
	}
	public void setHref(String href) {
		this.href = href;
	}
	public String getTitle() {
		return title;
	}
	public void setTitle(String title) {
		this.title = title;
	}
	public String getType() {
		return type;
	}
	public void setType(String type) {
		this.type = type;
	}
	public String getUrl() {
		return url;
	}
	public void setUrl(String url) {
		this.url = url;
	}
	public Long getVisitCount() {
		return visitCount;
	}
	public void setVisitCount(Long visitCount) {
		this.visitCount = visitCount;
	}
	public Long getDownloadCount() {
		return downloadCount;
	}
	public void setDownloadCount(Long downloadCount) {
		this.downloadCount = downloadCount;
	}
	public Date getModifyDate() {
		return modifyDate;
	}
	public void setModifyDate(Date modifyDate) {
		this.modifyDate = modifyDate;
	}
	
}
