package com.cxytiandi.baidu_pan.domain.es;

import org.springframework.data.annotation.Id;
import org.springframework.data.elasticsearch.annotations.Document;
import org.springframework.data.elasticsearch.annotations.Field;
import org.springframework.data.elasticsearch.annotations.FieldIndex;
import org.springframework.data.elasticsearch.annotations.FieldType;

@Document(indexName = "cxytiandi_pan", type = "pan")
public class ResourceBean {
	@Id
	@Field(type = FieldType.String, store = true, index = FieldIndex.not_analyzed)    
	private String id;
	
	@Field(type = FieldType.String, store = true, index = FieldIndex.analyzed, analyzer = "ik_max_word", searchAnalyzer = "ik_max_word")    
	private String title;
	
	@Field(type = FieldType.String, index = FieldIndex.not_analyzed)    
	private String type;
	
	@Field(type = FieldType.String, index = FieldIndex.not_analyzed)    
	private String url;
	
	@Field(type = FieldType.Long, index = FieldIndex.not_analyzed)    
	private long visitCount;
	
	@Field(type = FieldType.Long, index = FieldIndex.not_analyzed)    
	private long downloadCount;
	
	@Field(type = FieldType.String, index = FieldIndex.not_analyzed)    
	private String date;
	
	@Field(type = FieldType.String, index = FieldIndex.not_analyzed)    
	private String homeUrl;
	
	@Field(type = FieldType.String, index = FieldIndex.not_analyzed)    
	private String size;
	
	@Field(type = FieldType.String, index = FieldIndex.not_analyzed)    
	private String username;
	
	public String getId() {
		return id;
	}
	public void setId(String id) {
		this.id = id;
	}
	public String getTitle() {
		return title;
	}
	public void setTitle(String title) {
		this.title = title;
	}
	public String getDate() {
		return date;
	}
	public void setDate(String date) {
		this.date = date;
	}
	public String getHomeUrl() {
		return homeUrl;
	}
	public void setHomeUrl(String homeUrl) {
		this.homeUrl = homeUrl;
	}
	public String getSize() {
		return size;
	}
	public void setSize(String size) {
		this.size = size;
	}
	public String getUsername() {
		return username;
	}
	public void setUsername(String username) {
		this.username = username;
	}
	public String getType() {
		return type;
	}
	public void setType(String type) {
		this.type = type;
	}
	public String getUrl() {
		return url;
	}
	public void setUrl(String url) {
		this.url = url;
	}
	public Long getVisitCount() {
		return visitCount;
	}
	public void setVisitCount(Long visitCount) {
		this.visitCount = visitCount;
	}
	public Long getDownloadCount() {
		return downloadCount;
	}
	public void setDownloadCount(Long downloadCount) {
		this.downloadCount = downloadCount;
	}
}
