package com.cxytiandi.baidu_pan.service;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.cxytiandi.baidu_pan.domain.es.ResourceBean;
import com.cxytiandi.baidu_pan.repository.ResourceBeanRepository;
import com.cxytiandi.baidu_pan.repository.ResourceRepository;
import com.cxytiandi.baidu_pan.util.PageBean;

@Service
public class ResourceServiceImpl implements ResourceService {
	
	@Autowired
	private ResourceBeanRepository resourceBeanRepository;
	
	@Autowired
	private ResourceRepository resourceRepository;
	
	@Override
	public PageBean<ResourceBean> listForPage(String keyword, int type, int page, int limit) {
		return resourceBeanRepository.listForPage(keyword, type, page, limit);
	}

	@Override
	public ResourceBean getResource(String id) {
		return resourceRepository.findOne(id);
	}

	@Override
	public void addVisitCount(String id) {
		ResourceBean bean = this.getResource(id);
		bean.setVisitCount(bean.getVisitCount() + 1);
		resourceRepository.save(bean);
	}

	@Override
	public void addDownloadCount(String id) {
		ResourceBean bean = this.getResource(id);
		bean.setDownloadCount(bean.getDownloadCount() + 1);
		resourceRepository.save(bean);
	}

	@Override
	public List<ResourceBean> listByUser(String hmUrl) {
		return resourceRepository.findTop10ByHomeUrl(hmUrl);
	}

}
