package com.cxytiandi.baidu_pan.util;

import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.InetSocketAddress;
import java.net.Proxy;
import java.net.URL;
import java.net.URLEncoder;
import java.util.Map;
import java.util.zip.GZIPInputStream;

public class HttpClientUtil {

	public static String get(String pageUrl, String charSet) {
		try {
			URL url = new URL(pageUrl);
			HttpURLConnection conn = (HttpURLConnection) url.openConnection();
			conn.setRequestMethod("GET");
			conn.setRequestProperty("Accept",
					"text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,*/*;q=0.8");
			conn.setRequestProperty("Accept-Language", "zh-CN,zh;q=0.8");
			conn.setRequestProperty("Cache-Control", "max-age=0");
			conn.setRequestProperty("Upgrade-Insecure-Requests", "1");
			conn.setRequestProperty("Proxy-Connection", "keep-alive");
			conn.setRequestProperty("Referer", "http://cxytiandi.com/blog/user/1");
			conn.setRequestProperty("Host", "cxytiandi.com");
			conn.setRequestProperty("Accept-Encoding", "gzip, deflate, sdch");
			conn.setRequestProperty("User-Agent",
					"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.95 Safari/537.36");
			conn.connect();

			if (conn.getResponseCode() == 404) {
				return null;
			}

			BufferedReader reader = null;
			if (conn.getHeaderField("Content-Encoding") != null
					&& conn.getHeaderField("Content-Encoding").equals("gzip")) {
				reader = new BufferedReader(new InputStreamReader(new GZIPInputStream(conn.getInputStream()), charSet));
			} else {
				reader = new BufferedReader(new InputStreamReader(conn.getInputStream(), charSet));
			}

			String line = null;
			StringBuilder sb = new StringBuilder();
			while ((line = reader.readLine()) != null) {
				sb.append(line);
			}
			return sb.toString();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return null;
	}


	public static String get(String pageUrl, String charSet, String proxyIp, int proxyPort) {
		try {
			URL url = new URL(pageUrl);
			HttpURLConnection conn = (HttpURLConnection) url.openConnection(new Proxy(Proxy.Type.HTTP, new InetSocketAddress(proxyIp, proxyPort)));
			conn.setRequestMethod("GET");
			conn.setRequestProperty("Accept",
					"text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,*/*;q=0.8");
			conn.setRequestProperty("Accept-Language", "zh-CN,zh;q=0.8");
			conn.setRequestProperty("Cache-Control", "max-age=0");
			conn.setRequestProperty("Upgrade-Insecure-Requests", "1");
			conn.setRequestProperty("Proxy-Connection", "keep-alive");
			conn.setRequestProperty("Referer", "http://cxytiandi.com/blog/user/1");
			conn.setRequestProperty("Host", "cxytiandi.com");
			conn.setRequestProperty("Accept-Encoding", "gzip, deflate, sdch");
			conn.setReadTimeout(20000);
			conn.setRequestProperty("Cookie",
					"bdshare_firstime=1467894690712; un=\"jihuan900@126.com\"; pw=881140677f4433763deaeba76e5a3d03a768820e47cb7725eba86cecdb5ab402d0c798f6c7f47dc988f919baae1ead8c5e009816a33dbdd64a209ba62c036f626ef311b54e7717e22ba3ea8f4c23b150646e093f1205ac06e833f56f8f256f41092a182d888e02be5ccb5317248e321517e11e12253efc536b5a1edfea5e7f90; JSESSIONID=B8EB47D3A0AFA6F7649B4047B08DDDFB; Hm_lvt_e35f504c9feaa2efb5b48496bfcde2c6=1491187581,1491188380,1491224686,1491303980; Hm_lpvt_e35f504c9feaa2efb5b48496bfcde2c6=1491307980");
			conn.setRequestProperty("User-Agent",
					"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.95 Safari/537.36");
			conn.connect();

			if (conn.getResponseCode() == 404) {
				return null;
			}

			BufferedReader reader = null;
			if (conn.getHeaderField("Content-Encoding") != null
					&& conn.getHeaderField("Content-Encoding").equals("gzip")) {
				reader = new BufferedReader(new InputStreamReader(new GZIPInputStream(conn.getInputStream()), charSet));
			} else {
				reader = new BufferedReader(new InputStreamReader(conn.getInputStream(), charSet));
			}

			String line = null;
			StringBuilder sb = new StringBuilder();
			while ((line = reader.readLine()) != null) {
				sb.append(line);
			}
			return sb.toString();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return null;
	}
	
	public static String post(String pageUrl, Map<String, String> params, String charSet) {
		try {
			URL url = new URL(pageUrl);
			HttpURLConnection conn = (HttpURLConnection) url.openConnection();
			conn.setRequestMethod("POST");
			//参数要输出
			conn.setDoOutput(true);
			//不使用缓存
			conn.setUseCaches(false);
			conn.setConnectTimeout(60 * 1000);
			conn.setRequestProperty("Content-Type", "application/x-www-form-urlencoded; charset=UTF-8");
			conn.connect();
			if (params != null && params.keySet().size() > 0) {
				//kw=java&name=yjh
				StringBuilder sb = new StringBuilder();
				for (String key : params.keySet()) {
					sb.append(key + "=" + URLEncoder.encode(params.get(key), charSet) + "&");
				}
				String param = sb.delete(sb.length() - 1, sb.length()).toString();
				System.err.println(param);
				DataOutputStream out = new DataOutputStream(conn.getOutputStream());
				out.writeBytes(param);
				out.flush();
				out.close();
			}
			BufferedReader reader = null;
			if (conn.getHeaderField("Content-Encoding") != null
					&& conn.getHeaderField("Content-Encoding").equals("gzip")) {
				reader = new BufferedReader(new InputStreamReader(new GZIPInputStream(conn.getInputStream()), charSet));
			} else {
				reader = new BufferedReader(new InputStreamReader(conn.getInputStream(), charSet));
			}

			String line = null;
			StringBuilder sb = new StringBuilder();
			while ((line = reader.readLine()) != null) {
				sb.append(line);
			}
			conn.disconnect();
			return sb.toString();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return null;
	}
	
	public static String post(String pageUrl, Map<String, String> params,  Map<String, String> headers, String charSet) {
		try {
			URL url = new URL(pageUrl);
			HttpURLConnection conn = (HttpURLConnection) url.openConnection();
			conn.setRequestMethod("POST");
			//参数要输出
			conn.setDoOutput(true);
			//不使用缓存
			conn.setUseCaches(false);
			conn.setConnectTimeout(60 * 1000);
			for (String head : headers.keySet()) {
				conn.setRequestProperty(head, headers.get(head));
			}
			conn.connect();
			if (params != null && params.keySet().size() > 0) {
				//kw=java&name=yjh
				StringBuilder sb = new StringBuilder();
				for (String key : params.keySet()) {
					sb.append(key + "=" + URLEncoder.encode(params.get(key), charSet) + "&");
				}
				String param = sb.delete(sb.length() - 1, sb.length()).toString();
				System.err.println(param);
				DataOutputStream out = new DataOutputStream(conn.getOutputStream());
				out.writeBytes(param);
				out.flush();
				out.close();
			}
			BufferedReader reader = null;
			if (conn.getHeaderField("Content-Encoding") != null
					&& conn.getHeaderField("Content-Encoding").equals("gzip")) {
				reader = new BufferedReader(new InputStreamReader(new GZIPInputStream(conn.getInputStream()), charSet));
			} else {
				reader = new BufferedReader(new InputStreamReader(conn.getInputStream(), charSet));
			}

			String line = null;
			StringBuilder sb = new StringBuilder();
			while ((line = reader.readLine()) != null) {
				sb.append(line);
			}
			conn.disconnect();
			return sb.toString();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return null;
	}
}
