package com.cxytiandi.baidu_pan;

import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;
import org.junit.Ignore;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.test.context.junit4.SpringRunner;
import com.cxytiandi.baidu_pan.domain.Resource;
import com.cxytiandi.baidu_pan.util.HttpClientUtil;
/**
 * 数据爬取
 * @author 尹吉欢
 * qq:1304489315
 *
 */
@RunWith(SpringRunner.class)
@SpringBootTest(classes = App.class)
public class PanResourceSpider {
	@Autowired
	private MongoTemplate mongoTemplate;
	
	@Test
	@Ignore
	public void testsSpider() {
		for (int i = 1; i <= 2; i++) {
			//列表页面
			String url = "http://www.panduoduo.net/bd/" + i;
			String html = HttpClientUtil.get(url, "utf-8");
			Elements trs = Jsoup.parse(html).select(".list-resource tr");
			for (int j = 1; j < trs.size(); j++) {
				//抓取详情页面
				Element tr = trs.get(j);
				String title = tr.select(".t1 a").text();
				String href = "http://www.panduoduo.net" + tr.select(".t1 a").get(0).attr("href");
				System.out.println(title + "\t" + href);
				html = HttpClientUtil.get(href, "utf-8");
				Elements dds = Jsoup.parse(html).select(".slide2 .sep dl dd");
				String username = dds.get(0).select("a").get(0).text();
				String homeHref = "http://www.panduoduo.net" + dds.get(0).select("a").get(0).attr("href");
				String type = dds.get(1).select("a").get(0).text();
				String size = dds.get(2).select("b").get(0).text();
				String date = dds.get(5).text();
				date = date.substring(5);
				String resourceHref = Jsoup.parse(html).select(".dbutton2").get(0).attr("href");
				resourceHref = resourceHref.substring(resourceHref.indexOf("url=") + 4);
				
				//抓取百度云主页地址
				html = HttpClientUtil.get(homeHref, "utf-8");
				String baiduHref = Jsoup.parse(html).select(".info a").get(0).attr("href");
				baiduHref = baiduHref.substring(baiduHref.indexOf("url=") + 4);
				String homeUrl = null;
				try {
					homeUrl = URLDecoder.decode(baiduHref, "utf-8");
					resourceHref = URLDecoder.decode(resourceHref, "utf-8");
				} catch (UnsupportedEncodingException e) {
					e.printStackTrace();
				}
				System.out.println(username + "\t" + homeHref + "\t" + type + "\t" + size + "\t" + date + "\t" + homeUrl);
				Resource resource = new Resource();
				resource.setDate(date);
				resource.setHomeHref(homeHref);
				resource.setHomeUrl(homeUrl);
				resource.setHref(href);
				resource.setSize(size);
				resource.setTitle(title);
				resource.setType(type);
				resource.setUrl(resourceHref);
				resource.setUsername(username);
				mongoTemplate.save(resource);
			}
		}
	}
	
	@Test
	public void test() {
		String baiduHref = "http://139.196.166.21:8089/go.php?url=http%3A//pan.baidu.com/share/home%3Fuk%3D1782305673";
		baiduHref = baiduHref.substring(baiduHref.indexOf("url=") + 4);
		try {
			System.out.println(URLDecoder.decode(baiduHref, "utf-8"));
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
